/*
 *  MICO --- a CORBA 2.0 implementation
 *  Copyright (C) 1997, 1998 Kay Roemer & Arno Puder
 *
 *  This file was automatically generated. DO NOT EDIT!
 */

#if !defined(__GNOME_PANEL_H__) || defined(MICO_NO_TOPLEVEL_MODULES)
#define __GNOME_PANEL_H__

#ifndef MICO_NO_TOPLEVEL_MODULES
#include <CORBA.h>
#include <mico/throw.h>
#endif

// Generate forward declarations for this scope

// Module GNOME
#ifndef MICO_NO_TOPLEVEL_MODULES
MICO_NAMESPACE_DECL GNOME {
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_GNOME)

// Generate forward declarations for this scope
class Panel;
typedef Panel *Panel_ptr;
typedef Panel_ptr PanelRef;
typedef ObjVar<Panel> Panel_var;

class Applet;
typedef Applet *Applet_ptr;
typedef Applet_ptr AppletRef;
typedef ObjVar<Applet> Applet_var;



// Common definitions for interface Panel
class Panel : virtual public CORBA::Object
{
  public:
    virtual ~Panel();
    static Panel_ptr _duplicate( Panel_ptr obj );
    static Panel_ptr _narrow( CORBA::Object_ptr obj );
    static Panel_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual CORBA::Short applet_request_id( const char* cookie, const char* path, const char* param, CORBA::Short dorestart, char*& cfgpath, char*& globcfgpath, CORBA::ULong& wid ) = 0;
    virtual void applet_register( const char* cookie, const char* ior, CORBA::Short applet_id ) = 0;
    virtual void applet_abort_id( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual void applet_request_glob_cfg( const char* cookie, char*& globcfgpath ) = 0;
    virtual void applet_remove_from_panel( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual CORBA::Short applet_get_panel( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual CORBA::Short applet_get_pos( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual CORBA::Short applet_get_panel_orient( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual void applet_show_menu( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual void applet_drag_start( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual void applet_drag_stop( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual void applet_add_callback( const char* cookie, CORBA::Short applet_id, const char* callback_name, const char* menuitem_text ) = 0;
    virtual void applet_remove_callback( const char* cookie, CORBA::Short applet_id, const char* callback_name ) = 0;
    virtual void applet_add_tooltip( const char* cookie, CORBA::Short applet_id, const char* tooltip ) = 0;
    virtual void applet_remove_tooltip( const char* cookie, CORBA::Short applet_id ) = 0;
    virtual CORBA::Short applet_in_drag( const char* cookie ) = 0;
    virtual void sync_config( const char* cookie ) = 0;
    virtual void quit( const char* cookie ) = 0;
  protected:
    Panel() {};
  private:
    Panel( const Panel& );
    void operator=( const Panel& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Panel;

// Stub for interface Panel
class Panel_stub : virtual public Panel
{
  public:
    virtual ~Panel_stub();
    CORBA::Short applet_request_id( const char* cookie, const char* path, const char* param, CORBA::Short dorestart, char*& cfgpath, char*& globcfgpath, CORBA::ULong& wid );
    void applet_register( const char* cookie, const char* ior, CORBA::Short applet_id );
    void applet_abort_id( const char* cookie, CORBA::Short applet_id );
    void applet_request_glob_cfg( const char* cookie, char*& globcfgpath );
    void applet_remove_from_panel( const char* cookie, CORBA::Short applet_id );
    CORBA::Short applet_get_panel( const char* cookie, CORBA::Short applet_id );
    CORBA::Short applet_get_pos( const char* cookie, CORBA::Short applet_id );
    CORBA::Short applet_get_panel_orient( const char* cookie, CORBA::Short applet_id );
    void applet_show_menu( const char* cookie, CORBA::Short applet_id );
    void applet_drag_start( const char* cookie, CORBA::Short applet_id );
    void applet_drag_stop( const char* cookie, CORBA::Short applet_id );
    void applet_add_callback( const char* cookie, CORBA::Short applet_id, const char* callback_name, const char* menuitem_text );
    void applet_remove_callback( const char* cookie, CORBA::Short applet_id, const char* callback_name );
    void applet_add_tooltip( const char* cookie, CORBA::Short applet_id, const char* tooltip );
    void applet_remove_tooltip( const char* cookie, CORBA::Short applet_id );
    CORBA::Short applet_in_drag( const char* cookie );
    void sync_config( const char* cookie );
    void quit( const char* cookie );
  private:
    void operator=( const Panel_stub& );
};

class Panel_skel :
  virtual public MethodDispatcher,
  virtual public Panel
{
  public:
    Panel_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~Panel_skel();
    Panel_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    Panel_ptr _this();

};


// Common definitions for interface Applet
class Applet : virtual public CORBA::Object
{
  public:
    virtual ~Applet();
    static Applet_ptr _duplicate( Applet_ptr obj );
    static Applet_ptr _narrow( CORBA::Object_ptr obj );
    static Applet_ptr _nil();

    static vector<CORBA::Narrow_proto> *_narrow_helpers;
    virtual void *_narrow_helper( const char *repoid );
    static bool _narrow_helper2( CORBA::Object_ptr obj );

    virtual void change_orient( const char* cookie, CORBA::Short applet_id, CORBA::Short orient ) = 0;
    virtual void do_callback( const char* cookie, CORBA::Short applet_id, const char* callback_name ) = 0;
    virtual CORBA::Short session_save( const char* cookie, CORBA::Short applet_id, const char* cfgpath, const char* globcfgpath ) = 0;
    virtual void start_new_applet( const char* cookie, const char* param ) = 0;
  protected:
    Applet() {};
  private:
    Applet( const Applet& );
    void operator=( const Applet& );
};

MICO_EXPORT_DECL CORBA::TypeCode_ptr _tc_Applet;

// Stub for interface Applet
class Applet_stub : virtual public Applet
{
  public:
    virtual ~Applet_stub();
    void change_orient( const char* cookie, CORBA::Short applet_id, CORBA::Short orient );
    void do_callback( const char* cookie, CORBA::Short applet_id, const char* callback_name );
    CORBA::Short session_save( const char* cookie, CORBA::Short applet_id, const char* cfgpath, const char* globcfgpath );
    void start_new_applet( const char* cookie, const char* param );
  private:
    void operator=( const Applet_stub& );
};

class Applet_skel :
  virtual public MethodDispatcher,
  virtual public Applet
{
  public:
    Applet_skel( const CORBA::BOA::ReferenceData & = CORBA::BOA::ReferenceData() );
    virtual ~Applet_skel();
    Applet_skel( CORBA::Object_ptr obj );
    virtual bool dispatch( CORBA::ServerRequest_ptr _req, CORBA::Environment &_env );
    Applet_ptr _this();

};

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE_GNOME)

#ifndef MICO_NO_TOPLEVEL_MODULES

};
#endif

#if !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)

CORBA::Boolean operator<<=( CORBA::Any &a, const GNOME::Panel_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, GNOME::Panel_ptr &obj );

CORBA::Boolean operator<<=( CORBA::Any &a, const GNOME::Applet_ptr obj );
CORBA::Boolean operator>>=( const CORBA::Any &a, GNOME::Applet_ptr &obj );

#endif // !defined(MICO_NO_TOPLEVEL_MODULES) || defined(MICO_MODULE__GLOBAL)


#ifndef MICO_NO_TOPLEVEL_MODULES
#include <mico/template_impl.h>
#endif

#endif
